/**
* Original build by Theo Watson @ http://fffff.at/auto-smiley
* modified by Joey van der Bie @ http://www.vanderBie.net/2010/04/29/autosmiley-for-windows/
**/

#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){
	ofBackground(30,30,30);

    vision.setupCamera(0, 320, 240);

	//lets load the font from our app bundle
	//ofSetDataPathRoot("./");
	ttf.loadFont("MONACO.TTF", 48);
	ttfSmall.loadFont("MONACO.TTF", 14);

	//lets restore it
	//ofSetDataPathRoot("../../../");

	img.allocate(320, 240, OF_IMAGE_GRAYSCALE);

	lastTime = ofGetElapsedTimef()- 10.0;

	smilePct = 0.0;
	smoothPct = 0.0;
}

//--------------------------------------------------------------
void doSmily(){

    //For windows http://msdn.microsoft.com/en-us/library/ms646304%28v=VS.85%29.aspx
    //codes from http://msdn.microsoft.com/en-us/library/dd375731%28v=VS.85%29.aspx
    keybd_event( VK_SPACE,0,0,0);                     // - SPACE down
    keybd_event( VK_SPACE,0,KEYEVENTF_KEYUP,0);       // - SPACE up

    keybd_event( (0x10),0,0,0);                     // - SHIFT down

    keybd_event( (0xBA),0,0,0);                     // - : key down
    keybd_event( (0xBA),0,KEYEVENTF_KEYUP,0);       // - : key up

    keybd_event( (0x30),0,0,0);                     // - ) key down
    keybd_event( (0x30),0,KEYEVENTF_KEYUP,0);       // - ) key up

    keybd_event( (0x10),0,KEYEVENTF_KEYUP,0);       // - SHIFT up

	//from http://74.125.47.132/search?q=cache:OtbdKJ8MQToJ:www.realsoftware.com/listarchives/realbasic-nug/2001-11/msg01823.html+CGKeyCode+shift&cd=2&hl=en&ct=clnk&gl=us&client=safari
	//codes from - http://ritter.ist.psu.edu/projects/RUI/macosx/rui.c
//
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)49, true );		// - SPACE down
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)49, false );		// - SPACE down
//
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)56, true );		// - SHIFT down
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)41, true );		// - : key down
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)41, false );		// - : up down
//
//
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)29, true );		// - ) key down
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)29, false );		// - ) up down
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)56, false );		// - SHIFT up
//
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)49, true );		// - ENTER down
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)49, false );		// - ENTER down
//
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)52, true );		// - ENTER down
//	CGPostKeyboardEvent( (CGCharCode)0, (CGKeyCode)52, false );		// - ENTER up
//

	//also
	//- http://stackoverflow.com/questions/2379867/simulating-key-press-events-in-mac-osx
//	CGEventSourceRef source = CGEventSourceCreate(kCGEventSourceStateCombinedSessionState);
//	CGEventRef saveCommandDown = CGEventCreateKeyboardEvent(source, (CGKeyCode)1, YES);
//	CGEventSetFlags(saveCommandDown, kCGEventFlagMaskCommand);
//	CGEventRef saveCommandUp = CGEventCreateKeyboardEvent(source, (CGKeyCode)1, NO);
//
//	CGEventPost(kCGAnnotatedSessionEventTap, saveCommandDown);
//	CGEventPost(kCGAnnotatedSessionEventTap, saveCommandUp);
//
//	CFRelease(saveCommandUp);
//	CFRelease(saveCommandDown);
//	CFRelease(source);
}

//--------------------------------------------------------------
void testApp::update(){
    vision.update();

	img.setFromPixels(vision.gray.getPixels(), vision.gray.width, vision.gray.height, OF_IMAGE_GRAYSCALE);

	ofxSmile::getSmile(img, smilePct);

	smoothPct *= 0.8;
	smoothPct += MAX(0, smilePct) * 0.2;

	if( ofGetElapsedTimef() - lastTime > 2.0 ){

		if( smoothPct > 0.50 ){
			doSmily();
			lastTime = ofGetElapsedTimef();
		}

	}

}

//--------------------------------------------------------------
void testApp::draw(){

	ofSetColor(0xffffff);
    vision.color.draw(0,0);

	ofDrawBitmapString("smile        = " + ofToString(smilePct, 2), 20, 20);
	ofDrawBitmapString("smile smooth = " + ofToString(smoothPct, 2), 20, 36);

	if( ofGetElapsedTimef() - lastTime < 1.0 ){
		ofSetColor(255, 255, 255, 100);
		ttf.drawString(":)", -50 + img.width/2, 30 + img.height/2);
	}

	float alpha = ofMap(  ofGetElapsedTimef() - lastTime, 1.0, 1.3, 255, 0.0, true);

	ofSetColor(255, 255, 255, alpha);
	ttfSmall.drawString("-> sending smiley :)", 10, 270);

}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){
    if(key == ' '){
        vision.togglePlayback();
    }

    //if you need to adjust the camera properties
    if(key == 's'){
        vision.camera.videoSettings();
    }
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mouseReleased(){

}
